---------------------TRATAMIENTOMEDICO----------------------------------------
CREATE OR REPLACE PROCEDURE ADD_TRA_MED_PROCE 
(FRTR IN NUMBER, TITR IN VARCHAR2, IDDI IN NUMBER) IS
BEGIN
    INSERT INTO TRATAMIENTOMEDICO
    (FRECUENCIA_TRA,TIPO_TRA,ID_DIAGNOSTICO) VALUES
    (FRTR, TITR, IDDI);
    COMMIT;
END;

CREATE SEQUENCE TRA_MED_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
  CREATE OR REPLACE TRIGGER TRA_MED_TRIGGER  
   BEFORE INSERT ON "CLINICA"."TRATAMIENTOMEDICO" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_TRATAMIENTO" IS NULL THEN 
         SELECT TRA_MED_SEQUENCE.NEXTVAL INTO :NEW."ID_TRATAMIENTO" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UPD_TRA_MED_PROCE 
(IDTR IN NUMBER, FRTR IN NUMBER , TITR VARCHAR2, IDDI IN NUMBER) 
IS
FT NUMBER;
TT VARCHAR2(1024);
IDD NUMBER;
BEGIN
  IF(FRTR=NULL)THEN
  SELECT FRECUENCIA_TRA INTO FT FROM TRATAMIENTOMEDICO WHERE ID_TRATAMIENTO = IDTR;
  ELSE
  FT := FRTR;
  END IF;
  IF(TITR=NULL)THEN
  SELECT TIPO_TRA INTO TT FROM TRATAMIENTOMEDICO WHERE ID_TRATAMIENTO = IDTR;
  ELSE
  TT := TITR;
  END IF;
  IF(IDDI=NULL)THEN
  SELECT ID_DIAGNOSTICO INTO IDD FROM TRATAMIENTOMEDICO WHERE ID_TRATAMIENTO = IDTR;
  ELSE
  IDD := IDDI;
  END IF;
  UPDATE TRATAMIENTOMEDICO
  SET FRECUENCIA_TRA=FT, TIPO_TRA=TT, ID_DIAGNOSTICO=IDD
  WHERE ID_TRATAMIENTO = IDTR;
  COMMIT;
END;

////////////////////////////////////////////////////////////////////////////////////
------------REGION----------------------------------------------------
CREATE OR REPLACE PROCEDURE ADD_REG_PROCE 
(CONT IN VARCHAR2, PAIS IN VARCHAR2) IS
BEGIN
    INSERT INTO REGION
    (CONTINIENTE,PAIS) VALUES
    (CONT,PAIS);
    COMMIT;
END;

CREATE SEQUENCE REG_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

 CREATE OR REPLACE TRIGGER REG_TRIGGER  
   BEFORE INSERT ON "CLINICA"."REGION" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_REGION" IS NULL THEN 
         SELECT REG_SEQUENCE.NEXTVAL INTO :NEW."ID_REGION" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UPD_REG_PROCE 
(IDRE IN NUMBER,  CONT VARCHAR2, PAI IN VARCHAR2) 
IS
CONTI VARCHAR2(1024);
PAIS VARCHAR2(1024);
BEGIN
  IF(CONT=NULL)THEN
  SELECT CONTINIENTE INTO  CONTI FROM REGION WHERE ID_REGION = IDRE;
  ELSE
  CONTI := CONT;
  END IF;
  IF(PAI=NULL)THEN
  SELECT PAIS INTO PAIS FROM REGION WHERE ID_REGION = IDRE;
  ELSE
  PAIS := PAI;
  END IF;
  UPDATE REGION
  SET CONTINIENTE=CONTI, PAIS=PAIS
  WHERE ID_REGION = IDRE;
  COMMIT;
END;

/////////////////////////////////////////////////////////////////////////////////
---------------------CLINICA----------------------------------------------------

create or replace PROCEDURE ADD_CLINICA_PROCE
(DIRECCION_CLI IN VARCHAR2,NOMBRE_CLI IN VARCHAR2,TELELFONO_CLI IN VARCHAR2, ID_REGION IN INTEGER) IS
BEGIN
    INSERT INTO CLINICA (DIRECCION_CLI,NOMBRE_CLI,TELELFONO_CLI, ID_REGION)
    VALUES (DIRECCION_CLI,NOMBRE_CLI,TELELFONO_CLI,ID_REGION);
    COMMIT;
END;

CREATE SEQUENCE CLINICA_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace trigger CLINICA_TRIGGER  
   before insert on "CLINICA"."CLINICA" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_CLINICA" is null then 
         select CLINICA_SEQUENCE.nextval into :NEW."ID_CLINICA" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_CLINICA_PROCE 
(ID_CLINICA IN INTEGER,DIRECCION_CLI IN VARCHAR2,NOMBRE_CLI IN VARCHAR2,TELELFONO_CLI IN VARCHAR2, ID_REGION IN NUMBER) 
IS
DICLI VARCHAR2(1024);
NOCLI VARCHAR2(1024);
TECLI VARCHAR2(1024);
IDREG NUMBER;
BEGIN
  IF(DIRECCION_CLI=NULL)THEN
  SELECT DIRECCION_CLI INTO  DICLI FROM CLINICA WHERE ID_CLINICA=ID_CLINICA;
  ELSE
  DICLI := DIRECCION_CLI;
  END IF;
  IF(NOMBRE_CLI=NULL)THEN
  SELECT NOMBRE_CLI INTO  NOCLI FROM CLINICA WHERE ID_CLINICA=ID_CLINICA;
  ELSE
  NOCLI := NOMBRE_CLI;
  END IF;
  IF(TELELFONO_CLI=NULL)THEN
  SELECT TELELFONO_CLI INTO  TECLI FROM CLINICA WHERE ID_CLINICA=ID_CLINICA;
  ELSE
  TECLI := TELELFONO_CLI;
  END IF;
  IF(ID_REGION=NULL)THEN
  SELECT ID_REGION INTO  IDREG FROM CLINICA WHERE ID_CLINICA=ID_CLINICA;
  ELSE
  IDREG := ID_REGION;
  END IF;
  UPDATE CLINICA
  SET DIRECCION_CLI=DICLI, NOMBRE_CLI=NOCLI, TELELFONO_CLI=TECLI, ID_REGION=IDREG
  WHERE ID_CLINICA=ID_CLINICA;
  COMMIT;
END;

///////////////////////////////////////////////////////////////////////////////////////
------------------HOSPITAL------------------------------------------------------------

create or replace PROCEDURE ADD_HOS_PROCE
(DIRHOS IN VARCHAR2,NOMHOS IN VARCHAR2, TELEHOS IN VARCHAR2, IDREG IN INTEGER) IS
BEGIN
    INSERT INTO HOSPITAL (DIRECCION_HOS,NOMBRE_HOS,TELEFONO_HOS,ID_REGION)
    VALUES (DIRHOS,NOMHOS,TELEHOS,IDREG);
    COMMIT;
END;

CREATE SEQUENCE HOS_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

 create or replace trigger HOS_TRIGGER  
   before insert on "CLINICA"."HOSPITAL" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_HOSPITAL" is null then 
         select HOS_SEQUENCE.nextval into :NEW."ID_HOSPITAL" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_CLINICA_PROCE 
(IDHOS IN NUMBER,DIRHOS IN VARCHAR2,NOMHOS IN VARCHAR2, TELEHOS IN VARCHAR2, IDRE IN NUMBER) 
IS
DIHOS VARCHAR2(1024);
NOHOS VARCHAR2(1024);
TEHOS VARCHAR2(1024);
IDREG NUMBER;
BEGIN
  IF(DIRHOS=NULL)THEN
  SELECT DIRECCION_HOS INTO  DIHOS FROM HOSPITAL WHERE ID_HOSPITAL=IDHOS;
  ELSE
  DIHOS := DIRHOS;
  END IF;
  IF(NOMHOS=NULL)THEN
  SELECT NOMBRE_HOS INTO  NOHOS FROM HOSPITAL WHERE ID_HOSPITAL=IDHOS;
  ELSE
  NOHOS := NOMHOS;
  END IF;
  IF(TELEHOS=NULL)THEN
  SELECT TELEFONO_HOS INTO  TEHOS FROM HOSPITAL WHERE ID_HOSPITAL=IDHOS;
  ELSE
  TEHOS := TELEHOS;
  END IF;
  IF(IDRE=NULL)THEN
  SELECT ID_REGION INTO  IDREG FROM HOSPITAL WHERE ID_HOSPITAL=IDHOS;
  ELSE
  IDREG := IDRE;
  END IF;
  UPDATE HOSPITAL
  SET DIRECCION_HOS=DIHOS, NOMBRE_HOS=NOHOS, TELEFONO_HOS=TEHOS, ID_REGION=IDREG
  WHERE ID_HOSPITAL=IDHOS;
  COMMIT;
END;

/////////////////////////////////////////////////////////////////////////////////////
----------------------------SALA----------------------------------------------------

create or replace PROCEDURE ADD_SAL_PROCE
(CS IN NUMBER,HS IN NUMBER, IDH IN NUMBER) IS
BEGIN
    INSERT INTO SALA (CAMA_SAL, HABITACION_SAL, ID_HOSPITAL)
    VALUES (CS,HS,IDH);
    COMMIT;
END;

CREATE SEQUENCE SAL_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
create or replace trigger SAL_TRIGGER  
   before insert on "CLINICA"."SALA" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_SALA" is null then 
         select SAL_SEQUENCE.nextval into :NEW."ID_SALA" from dual; 
      end if; 
   end if; 
end; 
 
create or replace PROCEDURE UPD_SAL_PROCE 
(IDS IN NUMBER,CS IN NUMBER,HS IN NUMBER, IDH IN NUMBER) 
IS
CAS NUMBER;
HAS NUMBER;
IDHO NUMBER;
BEGIN
  IF(CS=NULL)THEN
  SELECT CAMA_SAL INTO CAS FROM SALA WHERE ID_SALA=IDS;
  ELSE
  CAS := CS;
  END IF;
  IF(HS=NULL)THEN
  SELECT HABITACION_SAL INTO  HAS FROM SALA WHERE ID_SALA=IDS;
  ELSE
  HAS := HS;
  END IF;
  IF(IDH=NULL)THEN
  SELECT ID_HOSPITAL INTO IDHO FROM SALA WHERE ID_SALA=IDS;
  ELSE
  IDHO := IDH;
  END IF;
  UPDATE SALA
  SET CAMA_SAL=CAS, HABITACION_SAL=HAS, ID_HOSPITAL=IDHO
  WHERE ID_SALA=IDS;
  COMMIT;
END;
 
//////////////////////////////////////////////////////////////////////////////////////
-----------------------------HOSPITALIZACION------------------------------------------

create or replace PROCEDURE ADD_HOSPITALIZACION_PROCE
(FEINI IN DATE,FEFIN IN DATE, IDDOC IN NUMBER, IDPAC IN NUMBER, IDSAL IN NUMBER) IS
IDH NUMBER;
FEH DATE;
BEGIN
    INSERT INTO HOSPITALIZACION (FECHA_INICIO_HOSP,FECHA_FIN_HOSP,ID_DOCTOR, ID_PACIENTE, ID_SALA)
    VALUES (FEINI,FEFIN,IDDOC,IDPAC,IDSAL);
    COMMIT;
    SELECT MAX(ID_HOSPITALIZACION) INTO IDH FROM HOSPITALIZACION;
    SELECT SYSDATE INTO FEH FROM DUAL;
    INSERT INTO BITACORAPROCEDIMIENTOS (FECHA_BITACORA,TOTAL,ID_HOSPITALIZACION)
    VALUES (FEH,0,IDH);
    COMMIT;
END;
 
 CREATE SEQUENCE HOSPITALIZACION_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
create or replace trigger HOSPITALIZACION_TRIGGER  
   before insert on "CLINICA"."HOSPITALIZACION" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_HOSPITALIZACION" is null then 
         select HOSPITALIZACION_SEQUENCE.nextval into :NEW."ID_HOSPITALIZACION" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_HOSPITALIZACION_PROCE 
(IDHOS IN NUMBER,FEINI IN DATE,FEFIN IN DATE, IDDOC IN NUMBER, IDPAC IN NUMBER, IDSAL IN NUMBER) 
IS
FEI DATE;
FEF DATE;
IDDO NUMBER;
IDPA NUMBER;
IDSA NUMBER;
BEGIN
  IF(FEINI=NULL)THEN
  SELECT FECHA_INICIO_HOSP INTO FEI FROM HOSPITALIZACION WHERE ID_HOSPITALIZACION=IDHOS;
  ELSE
  FEI := FEINI;
  END IF;
  IF(FEFIN=NULL)THEN
  SELECT FECHA_FIN_HOSP INTO FEF FROM HOSPITALIZACION WHERE ID_HOSPITALIZACION=IDHOS;
  ELSE
  FEF := FEFIN;
  END IF;
  IF(IDDOC=NULL)THEN
  SELECT ID_DOCTOR INTO IDDO FROM HOSPITALIZACION WHERE ID_HOSPITALIZACION=IDHOS;
  ELSE
  IDDO := IDDOC;
  END IF;
  IF(IDPAC=NULL)THEN
  SELECT ID_PACIENTE INTO IDPA FROM HOSPITALIZACION WHERE ID_HOSPITALIZACION=IDHOS;
  ELSE
  IDPA := IDPAC;
  END IF;
  IF(IDSAL=NULL)THEN
  SELECT ID_SALA INTO IDSA FROM HOSPITALIZACION WHERE ID_HOSPITALIZACION=IDHOS;
  ELSE
  IDSA := IDSAL;
  END IF;
  UPDATE HOSPITALIZACION
  SET FECHA_INICIO_HOSP=FEI, FECHA_FIN_HOSP=FEF,ID_DOCTOR=IDDO,ID_PACIENTE=IDPA,ID_SALA=IDSA
  WHERE ID_HOSPITALIZACION=IDHOS;
  COMMIT;
END;

///////////////////////////////////////////////////////////////////////////////////////////////
------------------------BITACORAPROCEDIMIENTO-------------------------------------------------

CREATE SEQUENCE BITA_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace TRIGGER BITA_TRIGGER  
   BEFORE INSERT ON "CLINICA"."BITACORAPROCEDIMIENTOS" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_BITACORA" IS NULL THEN 
         SELECT BITA_SEQUENCE.NEXTVAL INTO :NEW."ID_BITACORA" FROM DUAL; 
      END IF; 
   END IF; 
END;

/////////////////////////////////////////////////////////////////////////////////////////////////
---------------------------COSTOPORSERVICIO-----------------------------------------------------

create or replace PROCEDURE ADD_COS_SER_PROCE 
(FECO IN DATE, UM IN VARCHAR2) IS
BEGIN

    INSERT INTO COSTOSPORSERVICIOS
    (FECHA_COSTO,TOTAL_COSTO,UNIDADMONETARIA) VALUES
    (FECO,0,UM);
    COMMIT;
END;

 CREATE SEQUENCE COS_SER_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

 
create or replace trigger COS_SER_TRIGGER  
   before insert on "CLINICA"."COSTOSPORSERVICIOS" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_COSTO" is null then 
         select COS_SER_SEQUENCE.nextval into :NEW."ID_COSTO" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_COS_SER_PROCE 
(IDCOS IN NUMBER,FECO IN DATE, UM IN VARCHAR2) 
IS
UMD VARCHAR2(1024);
FE DATE;
BEGIN
  IF(FECO=NULL)THEN
  SELECT Fecha_Costo INTO FE FROM COSTOSPORSERVICIOS WHERE Id_Costo=IDCOS; 
  ELSE
  FE := FECO;
  END IF;
  IF(UM=NULL)THEN
  SELECT UNIDADMONETARIA INTO UMD FROM COSTOSPORSERVICIOS WHERE Id_Costo=IDCOS; 
  ELSE
  UMD := UM;
  END IF;
  UPDATE COSTOSPORSERVICIOS
  SET FECHA_COSTO=FE, UNIDADMONETARIA=UM
  WHERE Id_Costo=IDCOS; 
  COMMIT;
END;

////////////////////////////////////////////////////////////////////////////////////////////////
-------------------------MEDICAMENTO---------------------------------------------------------

create or replace PROCEDURE ADD_MEDCA_PROCE 
(DOC IN VARCHAR2, IDBI IN NUMBER, IDCM IN NUMBER, IDCO IN NUMBER, IDTR IN NUMBER) IS
BEGIN
    IF(IDBI=0) THEN
    INSERT INTO MEDICAMENTO
    (DOCIS_MED, ID_BITACORA ,ID_CAT_MEDI, ID_COSTO, ID_TRATAMIENTO) VALUES
    (DOC, NULL, IDCM, IDCO, IDTR );
    COMMIT;
    END IF;
    IF(IDTR=0)THEN
    INSERT INTO MEDICAMENTO 
    (DOCIS_MED, ID_BITACORA ,ID_CAT_MEDI, ID_COSTO, ID_TRATAMIENTO) VALUES
    (DOC, IDBI, IDCM, IDCO, NULL );
    COMMIT;
    END IF;
END;

CREATE SEQUENCE MEDCA_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;

create or replace trigger MEDCA_TRIGGER  
   before insert on "CLINICA"."MEDICAMENTO" 
   for each row 
begin  
   if inserting then 
      if :NEW."ID_MEDICAMENTO" is null then 
         select MEDCA_SEQUENCE.nextval into :NEW."ID_MEDICAMENTO" from dual; 
      end if; 
   end if; 
end;

create or replace PROCEDURE UPD_MEDCA_PROCE 
(IDME IN NUMBER ,DOC IN VARCHAR2, IDBI IN NUMBER, IDCM IN NUMBER, IDCO IN NUMBER, IDTR IN NUMBER) 
IS
DOCI VARCHAR2(1024);
IDB NUMBER;
IDC NUMBER;
IDCOS NUMBER;
IDT NUMBER;
BEGIN
  IF(DOC=NULL)THEN
  SELECT DOCIS_MED INTO DOCI FROM MEDICAMENTO WHERE ID_MEDICAMENTO=IDME;
  ELSE
  DOCI := DOC;
  END IF;
  IF(IDBI=NULL)THEN
  SELECT ID_BITACORA INTO IDB FROM MEDICAMENTO WHERE ID_MEDICAMENTO=IDME;
  ELSE
  IDB := IDBI;
  END IF;
  IF(IDCM=NULL)THEN
  SELECT ID_CAT_MEDI INTO IDC FROM MEDICAMENTO WHERE ID_MEDICAMENTO=IDME;
  ELSE
  IDC := IDCM;
  END IF;
  IF(IDCO=NULL)THEN
  SELECT ID_COSTO INTO IDCOS FROM MEDICAMENTO WHERE ID_MEDICAMENTO=IDME;
  ELSE
  IDCOS := IDCO;
  END IF;
  IF(IDTR=NULL)THEN
  SELECT ID_TRATAMIENTO INTO IDT FROM MEDICAMENTO WHERE ID_MEDICAMENTO=IDME;
  ELSE
  IDT := IDTR;
  END IF;
  UPDATE MEDICAMENTO
  SET DOCIS_MED=DOCI, ID_BITACORA=IDB, ID_CAT_MEDI=IDC, ID_COSTO=IDC, ID_TRATAMIENTO=IDTR
  WHERE ID_MEDICAMENTO=IDME; 
  COMMIT;
END;

//////////////////////////////////////////////////////////////////////////////////////////
------------------TERAPIA--------------------------------------------------------------

CREATE OR REPLACE PROCEDURE ADD_TERA_PROCE 
(FETR IN DATE, IDBI IN NUMBER, IDCT IN NUMBER, IDCO IN NUMBER, IDTR IN NUMBER) IS
BEGIN
    INSERT INTO TERAPIA
    (FECHA_DE_TERA,ID_BITACORA ,ID_CAT_TERA, ID_COSTO, ID_TRATAMIENTO) VALUES
    (FETR, IDBI, IDCT, IDCO, IDTR );
    COMMIT;
END;

CREATE SEQUENCE TERA_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
CREATE OR REPLACE TRIGGER TERA_TRIGGER  
   BEFORE INSERT ON "CLINICA"."TERAPIA" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_TERAPIA" IS NULL THEN 
         SELECT TERA_SEQUENCE.NEXTVAL INTO :NEW."ID_TERAPIA" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UPD_TERA_PROCE 
(IDTERA IN NUMBER, FETR IN DATE, IDBI IN NUMBER, IDCT IN NUMBER, IDCO IN NUMBER, IDTR IN NUMBER) 
IS
FT DATE;
BI NUMBER;
CT NUMBER;
CO NUMBER;
TR NUMBER;
BEGIN
  IF(FETR=NULL)THEN
  SELECT FECHA_DE_TERA INTO FT FROM TERAPIA WHERE ID_TERAPIA=IDTERA;
  ELSE
  FT := FETR;
  END IF;
  IF(IDBI=NULL)THEN
  SELECT ID_BITACORA INTO BI FROM TERAPIA WHERE ID_TERAPIA=IDTERA;
  ELSE
  BI := IDBI;
  END IF;
  IF(IDCT=NULL)THEN
  SELECT ID_CAT_TERA INTO CT FROM TERAPIA WHERE ID_TERAPIA=IDTERA;
  ELSE
  CT := IDCT;
  END IF;
  IF(IDCO=NULL)THEN
  SELECT ID_COSTO INTO CO FROM TERAPIA WHERE ID_TERAPIA=IDTERA;
  ELSE
  CO := IDCO;
  END IF;
  IF(IDTR=NULL)THEN
  SELECT ID_TERAPIA INTO TR FROM TERAPIA WHERE ID_TERAPIA=IDTERA;
  ELSE
  TR := IDTR;
  END IF;
  UPDATE TERAPIA
  SET FECHA_DE_TERA=FT, ID_BITACORA=BI, ID_CAT_TERA=CT, ID_COSTO=CO, ID_TERAPIA=TR
  WHERE ID_TERAPIA=IDTERA;
  COMMIT;
END;

/////////////////////////////////////////////////////////////////////////////////////////
--------------------------CIRUGIA-------------------------------------------------------

create or replace PROCEDURE ADD_CIRU_PROCE 
(FECI IN DATE, HC IN VARCHAR2,PC IN VARCHAR2 ,IDBI IN NUMBER, IDCC IN NUMBER, IDCO IN NUMBER) IS
BEGIN
    INSERT INTO CIRUGIA
    (FECHA_CIRU,HORA_CIRU,PROCESO_CIRU,ID_BITACORA,ID_CAT_CIRU,ID_COSTO) VALUES
    (FECI,HC,PC,IDBI,IDCC,IDCO);
    COMMIT;
END;

CREATE SEQUENCE CIRU_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
CREATE OR REPLACE TRIGGER CIRU_TRIGGER  
   BEFORE INSERT ON "CLINICA"."CIRUGIA" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_CIRUGIA" IS NULL THEN 
         SELECT CIRU_SEQUENCE.NEXTVAL INTO :NEW."ID_CIRUGIA" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UPD_CIRU_PROCE 
(IDCI IN NUMBER,FECI IN DATE, HC IN VARCHAR2, PC IN VARCHAR2 ,IDBI IN NUMBER, IDCC IN NUMBER, IDCO IN NUMBER) 
IS
FC DATE;
HCI VARCHAR(100);
CT NUMBER;
IB NUMBER;
ICC NUMBER;
IC NUMBER;
PRC VARCHAR(1024);
BEGIN
  IF(FECI=NULL)THEN
  SELECT FECHA_CIRU INTO FC FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  FC := FECI;
  END IF;
  IF(HC=NULL)THEN
  SELECT HORA_CIRU INTO HCI FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  HCI := HC;
  END IF;
  IF(PC=NULL)THEN
  SELECT PROCESO_CIRU INTO PRC FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  PRC := PC;
  END IF;
  IF(IDBI=NULL)THEN
  SELECT ID_BITACORA INTO IB FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  IB := IDBI;
  END IF;
  IF(IDCC=NULL)THEN
  SELECT ID_CAT_CIRU INTO ICC FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  ICC := IDCC;
  END IF;
  IF(IDCO=NULL)THEN
  SELECT ID_COSTO INTO IC FROM CIRUGIA WHERE ID_CIRUGIA=IDCI;
  ELSE
  IC := IDCO;
  END IF;
  UPDATE CIRUGIA
  SET FECHA_CIRU=FC, HORA_CIRU=HCI, PROCESO_CIRU=PRC, ID_BITACORA=IB, ID_CAT_CIRU=ICC, ID_COSTO=IC
  WHERE ID_CIRUGIA=IDCI;
  COMMIT;
END;

//////////////////////////////////////////////////////////////////////////////////////////////////////
------------------------------------SEGUIMIENTOCIRUGIA------------------------------------------------

create or replace PROCEDURE ADD_SEG_CIR_PROCE 
(TS IN VARCHAR2, IC IN NUMBER) IS
BEGIN
    INSERT INTO SEGUIMIENTOCIRUGIA
    (TIPO_SEGUIMIENTO, ID_CIRUGIA) VALUES
    (TS,IC);
    COMMIT;
END;

CREATE SEQUENCE SEG_CIR_SEQUENCE
 START WITH     1
 INCREMENT BY   1
 NOCACHE
 NOCYCLE;
 
CREATE OR REPLACE TRIGGER SEG_CIR_TRIGGER  
   BEFORE INSERT ON "CLINICA"."SEGUIMIENTOCIRUGIA" 
   FOR EACH ROW 
BEGIN  
   IF INSERTING THEN 
      IF :NEW."ID_SEGUIMIENTO" IS NULL THEN 
         SELECT SEG_CIR_SEQUENCE.NEXTVAL INTO :NEW."ID_SEGUIMIENTO" FROM DUAL; 
      END IF; 
   END IF; 
END;

create or replace PROCEDURE UPD_SEG_CIR_PROCE 
(ISC IN NUMBER, TS IN VARCHAR2, IC IN NUMBER ) 
IS
TSE VARCHAR2(1024);
ICI NUMBER;
BEGIN
  IF(TS=NULL)THEN
  SELECT TIPO_SEGUIMIENTO INTO TSE FROM SEGUIMIENTOCIRUGIA WHERE ID_SEGUIMIENTO=ISC;
  ELSE
  TSE := TS;
  END IF;
  IF(IC=NULL)THEN
  SELECT ID_CIRUGIA INTO ICI FROM SEGUIMIENTOCIRUGIA WHERE ID_SEGUIMIENTO=ISC;
  ELSE
  ICI := IC;
  END IF;
  UPDATE SEGUIMIENTOCIRUGIA
  SET TIPO_SEGUIMIENTO=TSE, ID_CIRUGIA=ICI
  WHERE ID_SEGUIMIENTO=ISC;
  COMMIT;
END;






